<?php

declare(strict_types=1);

namespace App\Policies;

use Illuminate\Foundation\Auth\User as AuthUser;
use App\Models\Transmittal;
use Illuminate\Auth\Access\HandlesAuthorization;

class TransmittalPolicy
{
    use HandlesAuthorization;
    
    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:Transmittal');
    }

    public function view(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('View:Transmittal');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:Transmittal');
    }

    public function update(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('Update:Transmittal');
    }

    public function delete(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('Delete:Transmittal');
    }

    public function restore(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('Restore:Transmittal');
    }

    public function forceDelete(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('ForceDelete:Transmittal');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:Transmittal');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:Transmittal');
    }

    public function replicate(AuthUser $authUser, Transmittal $transmittal): bool
    {
        return $authUser->can('Replicate:Transmittal');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:Transmittal');
    }

}